--- old/usr/src/cmd/nscd/cache.c	Mon Oct 15 13:24:28 2018
+++ new/usr/src/cmd/nscd/cache.c	Mon Oct 15 13:24:29 2018
@@ -22,6 +22,7 @@
  * Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2012 Milan Jurik. All rights reserved.
  * Copyright (c) 2016 by Delphix. All rights reserved.
+ * Copyright 2018 Joyent, Inc.
  */
 
 /*
@@ -1817,8 +1818,10 @@
 static void
 revalidate(nsc_ctx_t *ctx)
 {
+	(void) thr_setname(thr_self(), "revalidate");
+
 	for (;;) {
-		int 		i, slp, interval, count;
+		int i, slp, interval, count;
 
 		(void) rw_rdlock(&ctx->cfg_rwlp);
 		slp = ctx->cfg.pos_ttl;
@@ -1961,6 +1964,8 @@
 do_update(nsc_lookup_args_t *in) {
 	nss_pheader_t	*phdr = (nss_pheader_t *)in->buffer;
 
+	(void) thr_setname(thr_self(), "do_update");
+
 	/* update the length of the data buffer */
 	phdr->data_len = phdr->pbufsiz - phdr->data_off;
 
@@ -2017,7 +2022,7 @@
 static void
 ctx_invalidate(nsc_ctx_t *ctx)
 {
-	int 		i;
+	int		i;
 	nsc_entry_t	*entry;
 	char		*me = "ctx_invalidate";
 
@@ -2190,6 +2195,8 @@
 	ulong_t		nsc_entries;
 	char		*me = "reaper";
 
+	(void) thr_setname(thr_self(), me);
+
 	for (;;) {
 		(void) mutex_lock(&ctx->stats_mutex);
 		nsc_entries = ctx->stats.entries;
